﻿using System;

using Android.Widget;
using Android.Graphics.Drawables;
using Android.Content;
using Android.Util;
using Android.Views;

namespace Neteril
{
	public class TriStateImageView : View
	{
		public TriStateImageView (Context context) :
		base (context)
		{
			Initialize ();
		}

		public TriStateImageView (Context context, IAttributeSet attrs) :
		base (context, attrs)
		{
			Initialize ();
		}

		public TriStateImageView (Context context, IAttributeSet attrs, int defStyle) :
		base (context, attrs, defStyle)
		{
			Initialize ();
		}

		void Initialize ()
		{
		}

		int selectedIndex;

		public int SelectedIndex {
			get {
				return selectedIndex;
			}
			set {
				if (value < 0 || value > 2)
					throw new ArgumentOutOfRangeException ("value");
				JumpDrawablesToCurrentState ();
				selectedIndex = value;
				RefreshDrawableState ();
				Invalidate ();
			}
		}

		protected override int[] OnCreateDrawableState (int extraSpace)
		{
			switch (selectedIndex) {
			case 0:
				return new int[0];
			case 1:
				return new int[] { Android.Resource.Attribute.StateFirst };
			case 2:
				return new int[] { Android.Resource.Attribute.StateLast };
			default:
				return base.OnCreateDrawableState (extraSpace);
			}
		}
	}
}

